!(function (window, ns, bridge) {
  var exports = (window[ns] = window[ns] || {});
  if (typeof bridge === 'function') {
    bridge();
  }
  var createNamespace = function (name) {
    var arr = name.split('.'),
      space = window;
    arr.forEach(function (a) {
      !space[a] && (space[a] = {});
      space = space[a];
    });
    return space;
  };
  exports.define = function (name, fn) {
    var index = name.lastIndexOf('.'),
      ns = createNamespace(name.substring(0, index));
    ns[name.substring(index + 1)] = fn;
  };
})(window, 'browser', function () {
  var ad_bridge = window.ad_bridge;
  if (!ad_bridge) {
    return;
  }
  ad_bridge.callbackId = Math.floor(Math.random() * 2000000000);
  ad_bridge.callbacks = {};
  ad_bridge.adCallbacks = [];
  ad_bridge.version = '1.0.0';
  ad_bridge.exec = function (success, fail, service, action, args) {
    var callbackId = service + ad_bridge.callbackId++,
      argsJson = args ? JSON.stringify(args) : '';
    if (success || fail) {
      ad_bridge.callbacks[callbackId] = { success: success, fail: fail };
    }
    var ret = ad_bridge.nativeExec(service, action, callbackId, argsJson);
    if (ret === 'true') {
      return true;
    } else {
      if (ret === 'false') {
        return false;
      } else {
        return ret;
      }
    }
  };

  ad_bridge.callbackFromAd = function (event, args) {
    ad_bridge.adCallbacks.forEach((fn) => {
      fn(event, JSON.parse(args));
    });
  };

  ad_bridge.callbackFromNative = function (callbackId, args) {
    var callback = ad_bridge.callbacks[callbackId];
    var argsJson = JSON.parse(args);
    if (callback) {
      if (argsJson.succ) {
        callback.success && callback.success(argsJson.msg);
      } else {
        callback.fail && callback.fail(argsJson.msg);
      }
      if (!argsJson.keep) {
        delete ad_bridge.callbacks[callbackId];
      }
    }
  };
});
